//  COM Support Classes
//  Copyright  1996
//  B. W. Bush
//  All rights reserved
//
//  $RCSfile: IUnknown.cpp $
//  $Revision: 1.0 $
//  $State: Rel $
//  $Date: 1996/04/29 18:54:59 $


//  Include windows header files.
#include <windows>
#include <objbase>

//  Include COM support classes header files.
#include <com\IClassFactory.h>
#include <com\IUnknown.h>

//  Construct an instance aggregated with the specified unknown outer.
TIUnknown::TIUnknown(LPUNKNOWN unknownOuter)
  : fUnknownOuter(unknownOuter),
    fReferences(0)
{
    TIClassFactory::IncrementObjectCount();
}

//  Destroy an instance.
TIUnknown::~TIUnknown()
{
    TIClassFactory::DecrementObjectCount();
}

//  Return the unknown outer interface.
LPUNKNOWN TIUnknown::UnknownOuter()
{
    return fUnknownOuter != NULL ? fUnknownOuter : (LPUNKNOWN) this;
}

//  Add a reference to the private unknown implemenation.
ULONG STDMETHODCALLTYPE TIUnknown::AddRef()
{
    return ++fReferences;
}

//  Release a reference from the private unknown implemenation.
ULONG STDMETHODCALLTYPE TIUnknown::Release()
{
    const ULONG references = --fReferences;
    if (fReferences == 0)
        delete this;
    return references;
}

//  Throw a result code in case of failure.
void TIUnknown::CheckHResult(HRESULT result) throw(HRESULT)
{
    if (FAILED(result))
        throw result;
}

