//  COM Support Classes
//  Copyright  1996
//  B. W. Bush
//  All rights reserved
//
//  $RCSfile: IUnknown.h $
//  $Revision: 1.0 $
//  $State: Rel $
//  $Date: 1996/04/29 18:54:59 $


#ifndef BWB_IUnknown
#define BWB_IUnknown


//  Include windows header files.
#include <windows>
#include <objbase>

//  An implementation of the IUnknown interface.
class TIUnknown
  : public IUnknown
{
  public:

    //  Construct an instance aggregated with the specified unknown outer.
    TIUnknown(LPUNKNOWN unknownOuter = NULL);

    //  Return the unknown outer interface.
    LPUNKNOWN UnknownOuter();

    //  Add a reference to the private unknown implemenation.
    ULONG STDMETHODCALLTYPE AddRef();

    //  Release a reference from the private unknown implemenation.
    ULONG STDMETHODCALLTYPE Release();

  protected:

    //  Throw a result code in case of failure.
    static void CheckHResult(HRESULT result) throw(HRESULT);

  protected:

    //  Destroy an instance.
    virtual ~TIUnknown();

  private:

    //  Each instance is reference counted.
    ULONG fReferences;

    //  Each instance may have an unknown outer.
    LPUNKNOWN fUnknownOuter;
};


#endif // BWB_IUnknown

